package be.iminds.ilabt.jfed.experimenter_gui.slice.espec.model;

import javafx.beans.property.ObjectProperty;
import javafx.beans.property.SimpleObjectProperty;
import javafx.beans.property.SimpleStringProperty;
import javafx.beans.property.StringProperty;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.event.Event;
import javafx.event.EventHandler;


public class ESpecStateItem {
    public enum ESpecStateStatus { SUCCESS, FAILURE, RUNNING, FUTURE }
    private final ObjectProperty<ESpecStateStatus> status = new SimpleObjectProperty<>();
    private final StringProperty name = new SimpleStringProperty();
    private final ObservableList<ESpecStateItem> children = FXCollections.observableArrayList();
    private final ObjectProperty<EventHandler<Event>> onDetailsView = new SimpleObjectProperty<>();


    public ESpecStateItem(String name, ESpecStateStatus status) {
        this.name.set(name);
        this.status.set(status);
    }

    public ESpecStateItem(String name) {
        this(name, ESpecStateStatus.FUTURE);
    }

    public ESpecStateStatus getStatus() {
        return status.get();
    }

    public ObjectProperty<ESpecStateStatus> statusProperty() {
        return status;
    }

    public void setStatus(ESpecStateStatus status) {
        this.status.set(status);
    }

    public String getName() {
        return name.get();
    }

    public StringProperty nameProperty() {
        return name;
    }

    public void setName(String name) {
        this.name.set(name);
    }

    public ObservableList<ESpecStateItem> getChildren() {
        return children;
    }

    public EventHandler<Event> getOnDetailsView() {
        return onDetailsView.get();
    }

    public ObjectProperty<EventHandler<Event>> onDetailsViewProperty() {
        return onDetailsView;
    }

    public void setOnDetailsView(EventHandler<Event> onDetailsView) {
        this.onDetailsView.set(onDetailsView);
    }
}
